import tkinter as tk
import random
import itertools

class Balls:
    def __init__(self,x,y,dx,dy,color,n):
        self.x=x
        self.y=y
        self.dx=dx
        self.dy=dy
        self.color=color
        self.n=n

    def move(self):
        canvas.delete(self.n)     
        self.x=self.x+self.dx
        self.y=self.y+self.dy
        self.n=canvas.create_oval(self.x-r,self.y-r,self.x+r,self.y+r,fill=self.color,width=0)
        if self.x<0 or canvas.winfo_width()<self.x:
            self.x=self.x-self.dx
            self.dx=-self.dx
        if self.y<0 or canvas.winfo_height()<self.y:
            self.y=self.y-self.dy
            self.dy=-self.dy
            
    def bound():
        global l
        for a,b in itertools.combinations(balls, 2):
            if -2*r<=a.x-b.x<=2*r and -2*r<=a.y-b.y<=2*r:
                l=(a.x-b.x)**2+(a.y-b.y)**2
                if 0<l<(r*2)**2:
                    m1=(complex(a.dx,a.dy))/(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                    n1=m1.imag
                    m2=(complex(b.dx,b.dy))/(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                    n2=m2.imag
                    p1=(complex(a.dx,a.dy))/(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                    q1=p1.real
                    p2=(complex(b.dx,b.dy))/(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                    q2=p2.real
                    s1=complex(q2,n1)
                    s2=complex(q1,n2)
                    t1=s1*(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                    t2=s2*(complex(a.x-b.x,a.y-b.y)/abs(complex(a.x-b.x,a.y-b.y)))
                    a.dx=t1.real
                    a.dy=t1.imag
                    b.dx=t2.real
                    b.dy=t2.imag

                    a.x=a.x+a.dx
                    a.y=a.y+a.dy
                    b.x=b.x+b.dx
                    b.y=b.y+b.dy
                    l=(a.x-b.x)**2+(a.y-b.y)**2
                    if 0<l<(r*2)**2:
                        while 0<l<(r*2)**2:
                            a.x=a.x+a.dx
                            a.y=a.y+a.dy
                            b.x=b.x+b.dx
                            b.y=b.y+b.dy
                            l=(a.x-b.x)**2+(a.y-b.y)**2
                    else:
                        a.x=a.x-a.dx
                        a.y=a.y-a.dy
                        b.x=b.x-b.dx
                        b.y=b.y-b.dy    

v=2
r=60
l=None

balls=[
    Balls(120,80,random.choice([-v,v]),random.choice([-v,v]),"#0066CC",None),
    Balls(180,620,random.choice([-v,v]),random.choice([-v,v]),"#00CCFF",None),
    Balls(720,80,random.choice([-v,v]),random.choice([-v,v]),"#00FFFF",None),
    Balls(780,620,random.choice([-v,v]),random.choice([-v,v]),"#99CCFF",None),
    Balls(350,350,random.choice([-v,v]),random.choice([-v,v]),"#CCFFFF",None),
    Balls(550,350,random.choice([-v,v]),random.choice([-v,v]),"#3366FF",None)]

root=tk.Tk()
root.geometry("900x700")

canvas=tk.Canvas(root,width=900,height=700,bg="white")
canvas.place(x=0,y=0)

def loop():
    for a in balls:
        a.move()
    Balls.bound()
    root.after(10,loop)

loop()

root.mainloop()